Include      Hy17P.INC
Include      Main.inc

DEFINE       LCD=0              ;0=CAMRY   1=HYCON
MemorySize           EQU  256     ;HY15P53 RMA Size=128
QM_Zero_Wait_times   EQU  80h
QM_count_TH          EQU  10
ADC_Dis_count        EQU  2
;==============================================================

org   0000h
ProgramReset:
SoftReset:
	jmp      ProBegin
org   0004h
    Include  Interrupt.asm
;============================================================== 
ProBegin:
    Include  SysIni.asm

;==============================================================  
;LBSR 1 
;    mvl     2
;	mvf     17FH,f,b
;    mvl     30
;	mvf     17EH,f,b

	bcf     inte0,7,a             ;ҰBIEe_ ADC
    bcf     AD1CN0,ENAD1,a
    clrf    Temp,a
    mvff    Temp,BIEARL
    bsf     BIECN,BIERD,a         ;P_BIEO_Tե
    mvl     055H
    cpse    BIEDRH,a     
    jmp     readytoCal
    mvl     0aaH
    cpse    BIEDRL,a     
    jmp     readytoCal
    
Have_Cal:
    mvl     3                     ;P_{bmեȡAO_̷s@
    ADDF    BIEARL,f,a
    bsf     BIECN,BIERD,a
    mvl     055H
    cpse    BIEDRH,a
    jmp     BestNewCal
    mvl     0aaH
    cpse    BIEDRL,a     
    jmp     BestNewCal
    jmp     Have_Cal
  
BestNewCal:
    mvl     4                     ;T{ӦեȬ̷sե
    subf    BIEARL,f,a
    bsf     BIECN,BIERD,a
    mvff    BIEDRH,FullWeight_L 
    mvff    BIEDRL,FullWeight_H   
    bsf     BIECN,BIERD,a
    mvff    BIEDRH,ADCGain_L
    mvff    BIEDRL,ADCGain_M
    bsf     BIECN,BIERD,a
    mvff    BIEDRH,ADCGain_H
    
    mvf     BIEDRL,w,a
    andl    80h
    bcf     ADCFg,b_NGain,a
    btsz    WREG,7
    bsf     ADCFg,b_NGain,a 
    mvf     BIEDRL,w,a
    andl    0Fh
    mvf     ADshiftbit,f,a
    bsf     Flag1,b_CalFin,a      ;Nե
    
    bsf     inte0,7,a   
    bsf     AD1CN0,ENAD1,a 
    
;ssIɪADC
GetNewZero:
    btss    ADCFg,b_ADCint,ACCE    
    jmp     GetNewZero
    bcf     ADCFg,b_ADCint,ACCE
    mvff    ADNEWL,ADBuffL
    mvff    ADNEWM,ADBuffM
    mvff    ADNEWH,ADBuffH

    call    ADshiftbit_1
    mvff    ADBuffL,Cal_ADC_Z_L
    mvff    ADBuffM,Cal_ADC_Z_M
    mvff    ADBuffH,Cal_ADC_Z_H  
    jmp     Mainloop 
    
readytoCal:
	mvl     10100011b      ;GIE,ADC,PT1.1,PT10
    mvf     INTE0,F,ACCE 
    bsf     AD1CN0,ENAD1,a      
    jmp     Cal_main      
    
Mainloop:
    ;btsz    Flag1,b_idle          ;P_O_ݭniJidle mode
    ;jmp     QM_start
    btsz    Flag1,b_key10
    jmp     Main_KeyPT10
    btsz    Flag1,b_key11
    jmp     Main_KeyPT11
    btss    ADCFg,b_ADCint,ACCE
    jmp     Mainloop
    bcf     ADCFg,b_ADCint,ACCE
    mvff    ADNEWL,ADBuffL
    mvff    ADNEWM,ADBuffM
    mvff    ADNEWH,ADBuffH
    call    ADshiftbit_1
    btsz    Flag1,b_RawData,a      ;P_O`g٬ORawdata
    jmp     ShowRawData
    call    Get_g    
    mvl	    ADC_Dis_count          ;JȡANڤWhֵ_ܤ@
    cpsl	ADgiveup,a
    jmp	    ssss
    inf	    ADgiveup,f,a
    jmp	    Mainloop 
  ssss:
    clrf    ADgiveup,a         
    call    ShowADC
    jmp     Mainloop
    
 ShowRawData:
    mvff    ADBuffL,Temp+4         ;Is  ShowADC_1e NܸƩbTemp+4~+6  
    mvff    ADBuffM,Temp+5
    mvff    ADBuffH,Temp+6    
    call    ShowADC_PN
    jmp     Mainloop    
      


  
;===============================================    
Main_KeyPT10:
     btsz    Flag1,b_sleep,a    
     jmp     sleepmode
     bcf     Flag1,b_key10,a
     btgf    Flag1,b_RawData,a
     jmp     Mainloop
	 
Main_KeyPT11:
     bcf     Flag1,b_key11,a
     btsz    Flag1,b_idle,a
	 jmp     idle_start_set
Get_Zero_again:     
     btss    ADCFg,b_ADCint,ACCE    
     jmp     Get_Zero_again
     bcf     ADCFg,b_ADCint,ACCE
     mvff    ADNEWL,ADBuffL
     mvff    ADNEWM,ADBuffM
     mvff    ADNEWH,ADBuffH

     call    ADshiftbit_1
     mvff    ADBuffL,Cal_ADC_Z_L
     mvff    ADBuffM,Cal_ADC_Z_M
     mvff    ADBuffH,Cal_ADC_Z_H     
	 jmp     Mainloop
	 
	 
idle_start_set:
     call    AccuracyModeADCOFF
     nopf    AccuracyModeADCOFF
	 clrf    LCDCN1,b
     bsf     PWRCN,CSFON
     bcf     CSFCN1,ENBOR2	 
     bsf     CSFCN1,ENSDRV 
	 bcf     PWRCN,CSFON
     mvl     90H            
     mvf     AD1CN0,f,a
     bsf     AD1CN4,INX1,a     
     bsf     AD1CN4,INX0,a
     mvl     QM_Zero_Wait_times
  QM_ZeroGet_Wait:     
     btss    ADCFg,b_ADCint,ACCE   
     jmp     QM_ZeroGet_Wait
     dcsz    WREG,W                ;hTOOTsI
     jmp     QM_ZeroGet_Wait
         
     mvff    ADNEWL,ADBuffL
     mvff    ADNEWM,ADBuffM
     mvff    ADNEWH,ADBuffH
     call    ADshiftbit_1

     mvff    ADBuffL,QM_ZeroL      
     mvff    ADBuffM,QM_ZeroM
     mvff    ADBuffH,QM_ZeroH
    ; LDPR    100H,1
idle_mode:     
     bcf     TMA1CN,ENTMA1,a
     mvl     10010000b
     mvf     TMA1CN,f,a
     bcf     AD1CN0,ENAD1,a
     call    AccuracyModeADCOFF
     nopf    AccuracyModeADCOFF 
     bsf     PWRCN,CSFON        
     bcf     CSFCN1,ENSDRV
	 bcf     PWRCN,CSFON
     bsf     OSCCN0,OSCS0,a        ;CPU=LPO
     bcf     OSCCN2,ENHAO,a
     clrf    PWRCN,a
     bcf     ADCFg,b_ADCint,ACCE
     clrf    INTF0,a    
     clrf    INTF1,a
     idle
     nop
     nop    
QM_start:   ;bidle modeUAȬOCTMA_AΧCtOSR_ӧP_O_jqADCܤƶq
    bsf     OSCCN2,ENHAO,a  
    bcf     OSCCN0,OSCS0,a        ;CPU=HAO
    bsf     PWRCN,ENBGR
    bsf     PWRCN,ENLDO
    bsf     PWRCN,CSFON
    bsf     CSFCN1,ENSDRV
	bcf     PWRCN,CSFON
	mvl     90H                   ;OSR=128
    mvf     AD1CN0,f,a
    bsf     AD1CN4,INX1,a     
    bsf     AD1CN4,INX0,a
	

    call    Delay1ms

     
  QM_wait:                   ;IDLEҦUAӧP_ADCȬO_jqܰ
    btss    ADCFg,b_ADCint,ACCE   
    jmp     QM_wait

	bcf     ADCFg,b_ADCint,A
    mvff    ADNEWL,ADBuffL
    mvff    ADNEWM,ADBuffM
    mvff    ADNEWH,ADBuffH
    call    ADshiftbit_1   
    
    bcf	    mstat,c,a
    mvff	QM_ZeroL,temp+1
    mvff	QM_ZeroM,temp+2
    mvff	QM_ZeroH,temp+3
    mvf     ADBuffL,w,a
    subc    temp+1,f,a;low  	
    mvf	    ADBuffM,w,a
	subc    temp+2,f,a;middle
    mvf	    ADBuffH,w,a
	subc    temp+3,f,a;high
	
	;clrf    temp+3
    ;mvff    17FH,temp+2
	;mvff    17EH,temp+1
	
	tfsz	temp+3,a
	jmp	    QM_negativecheck
	mvf     QM_threshold_M,w,a   	;WLMcount+1
	cpsg    temp+2,a
	jmp     CP_QMT_M
	jmp     gotomaimloop
CP_QMT_M:	
	mvf	    QM_threshold_M,w,a;2
	cpsl	temp+2,a
	jmp	    cp_QMT_L
	jmp	    keepidle       
cp_QMT_L:
    mvf	    QM_threshold_L,w,a;2
	cpsl	temp+1,a
	jmp	    gotomaimloop
	jmp	    keepidle 	
	
QM_negativecheck:   
    comf    temp+1,f,a
    comf    temp+2,f,a
    comf    temp+3,f,a 
    INF     temp+1,f,a          
    mvl     0                 
    ADDC    temp+2,f,a        
    ADDC    temp+3,f,a
    
    tfsz    temp+3,a
    jmp     gotomaimloop
    mvf	    QM_threshold_M,w,a;2
	cpsg	temp+2,a
    jmp     CP_QMT_M
	jmp     gotomaimloop       			 
       

keepidle:
     ;mvff  temp+1,poinc1
	 ;mvff  temp+2,poinc1
     bsf   PT1,PT13
	 nop
	 nop
	 bcf   PT1,PT13
     clrf    QM_count,a        
     jmp    idle_mode
     jmp     QM_start
gotomaimloop:
     ;mvff  temp+1,poinc1
	 ;mvff  temp+2,poinc1
     bsf   PT1,PT12
	 nop
	 nop
	 bcf   PT1,PT12
     inf   QM_count,f,a
     mvl   QM_count_TH
     cpsl  QM_count,a
     jmp   QM_wait
	 ;ldpr  00,1
     jmp   idle_get_up	 


sleepmode:
    
     bcf     Flag1,b_sleep,a
     clrf    LCDCN1,b
     bcf     AD1CN0,ENAD1,a
     call    AccuracyModeADCOFF 
     nopf    AccuracyModeADCOFF  
     bsf     PWRCN,CSFON
	 bcf     CSFCN1,ENBOR2
	 bsf     PWRCN,CSFON	 
     clrf    PWRCN,a
     bcf     ADCFg,b_ADCint,ACCE
     clrf    INTF0,a    
     clrf    INTF1,a
	 nop
	 slp
     nop
	 nop
idle_get_up:	 
sleepgetup:	 
     bsf     PWRCN,ENBGR
     bsf     PWRCN,ENLDO
     clrf    QM_count,a  
     mvl     81H
     mvf     AD1CN0,f,a
     mvl	 11001000b	;TMACLK=DMS_CK/256/16=244hz
     mvf     TMA1CN,F,ACCE           
     mvl     11001000b
     mvf     LCDCN1,F,b
     bcf     PWRCN,CSFON
     bcf     CSFCN1,ENSDRV
     bcf     AD1CN4,INX1,a     
     bcf     AD1CN4,INX0,a     
     call	 PGAandADCAccuracyMode;PGA+ADC initialized. 
     nopf    PGAandADCAccuracyMode         
     bcf     Flag1,b_idle
	 bcf     Flag1,b_key10,a
	 bcf     Flag1,b_key11,a
     jmp     Mainloop   




         
;;;;;;;;;;;;;;;;;;;B 
    ;=========================ADC-Zero
Get_g:    
     BCF      MSTAT,c,ACCE             
     mvf      Cal_ADC_Z_L,w,a               
     subc     ADBuffL,f,a
     mvf      Cal_ADC_Z_M,w,a
     subc     ADBuffM,f,a
     mvf      Cal_ADC_Z_H,w,a
     subc     ADBuffH,f,a              ;
     
     mvff     ADBuffL,Temp+4
     mvff     ADBuffM,Temp+5
     mvff     ADBuffH,Temp+6
     
     bcf      ADCFg,b_N,a
     btsz     ADBuffH,7,a
     call     PtoN      
    
    
     ;====================  (ADC-Zero)/ADGain
    clrf    Temp+3,a 
    mvl     Temp+3
    mvf     md1,f,a
    mvl     ADCGain_L
    mvf     md2,f,a
    mvl     Temp+7
    mvf     md3,f,a
    mvl     4
    mvf     mdl1,f,a
    mvl     3
    mvf     mdl2,f,a
    mvl     4
    mvf     mdl3,f,a
    call    divide     
    
    mvff   Temp+7,Temp+4 
    mvff   Temp+8,Temp+5
    mvff   Temp+9,Temp+6
    ret




     


nop

include		ADC.asm             
include		Math.asm
IF  LCD=0     
include		LCDINDX_CAMRY.asm
ENDIF
IF  LCD=1
include		LCDINDX_HYCON.asm
ENDIF
include     calibration.asm

include		Display.asm
include     Subroutine.asm
Include  AvgADC.asm
include     ADCSetting.obj
include     17P56WR3.obj		;ϥθӵ{, ]wCPUCLK=00b=2Mhz; set CPUCLK=00b, disable interrupt source


;======================================================================================================= 
;========================================================================================================            
       END     